<?php

/**
 * Gpemovimentacao
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 19/04/2011 17:55:40 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Gpemovimentacao extends DaoGpeMovimentacao
{


    /**
     * Retorna a movimentacao mais recente do vinculo.
     *
     * @param integer    $nr_org            Numero da Organizacao.
     * @param integer    $nr_tipo_estrutura Numero da Estrutura.
     * @param integer    $nr_vinculo        Numero do Vinculo.
     * @param TkDateTime $dt_competencia    Data de competencia.
     *
     * @return array Gpemovimentacao
     */
    /*public static function retornaMovimentacaoRecentePorEstrutura(
        $nr_org, $nr_tipo_estrutura, $nr_vinculo, TkDateTime $dt_competencia
    ){

        $db = TkDb::singleton();
        $sql = 'SELECT *
                FROM GPE_MOVIMENTACAO M
                WHERE M.NRORG = '.$nr_org.'
                AND M.NRVINCULOM = '.$nr_vinculo.'
                AND M.DTINIMOVIMENT <= \''.$dt_competencia.'\'
                AND M.NRESTRUTURAM IN (
                                        SELECT NRESTRUTURAM
                                        FROM ESTRUTURAM
                                        WHERE NRTIPOESTRUTURA = '.$nr_tipo_estrutura.'
                                      )
                ORDER BY M.DTINIMOVIMENT DESC';

        $resultado = $db->fetchAll($sql);
        $objects = self::createObjectsFromArray($resultado);
        return $objects;
    }*/


    /**
     * Retorna instancia de GpemovimentacaoEntity.
     *
     * @param integer $nrOrg                Numero da Organizacao.
     * @param integer $nrVinculo            Numero do Vinculo.
     * @param string  $ultimoDiaCompetencia Ultimo dia do mes de competencia.
     *
     * @return array GpemovimentacaoEntity
     */
    public static function retornaMovimentacoes($nrOrg, $nrVinculo, $ultimoDiaCompetencia){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND NRVINCULOM = ?
            AND DTINIMOVIMENT <= ?',
            array(
                $nrOrg, $nrVinculo, $ultimoDiaCompetencia,
            ),
            'DTINIMOVIMENT DESC'
        );

        return $resultado;
    }


    /**
     * @param $nrOrg
     * @param $nrVinculo
     * @return array<GpemovimentacaoEntity>|null
     * @autor brunoborba 07/03/2013
     */
    public static function retornaMovimentacoesVinculo($nrOrg, $nrVinculo){
        //tk_warning($nrOrg.'  |  '.$nrVinculo);
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND NRVINCULOM = ?',

            array($nrOrg, $nrVinculo),

            'DTINIMOVIMENT'
        );
    return end($resultado);
    }


    /**
     * Retorna instancia de GpemovimentacaoEntity por tipo de movimentacao.
     *
     * @param integer $nrOrg                Numero da Organizacao.
     * @param integer $nrVinculo            Numero do Vinculo.
     * @param integer $tipo                 Tipo da Movimentacao.
     * @param string $ultimoDiaCompetencia Ultimo dia do mes de competencia.
     * @param $tipoestrutura
     *
     * @return array GpemovimentacaoEntity
     */
    public static function retornaMovimentacoesPorTipo($nrOrg, $nrVinculo, $tipo, $ultimoDiaCompetencia, $tipoestrutura){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND NRVINCULOM = ?
            AND NRTIPOTRANSFER = ?
            AND DTINIMOVIMENT <= ?
            AND NRTIPOESTRUTURA = ?',
            array(
                $nrOrg, $nrVinculo, $tipo, $ultimoDiaCompetencia, $tipoestrutura
            ),
            'DTINIMOVIMENT DESC'
        );

        return $resultado;
    }

    public static function retornaMovimentacoesPorHierarquia($nrOrg, $nrVinculo, $nrtipoestrutura, $dtIni, $dtFim){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND NRVINCULOM = ?
            AND NRTIPOESTRUTURA = ?
            AND DTINIMOVIMENT BETWEEN ? AND ?',
            array(
                $nrOrg, $nrVinculo, $nrtipoestrutura, $dtIni, $dtFim,
            ),
            'DTINIMOVIMENT DESC'
        );

        return $resultado;
    }

    public static function retornaMovimentacoesPeriodo($nrOrg, $nrVinculo, $dtInicio, $dtFim){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND NRVINCULOM = ?
            AND (DTFIMMOVIMENT BETWEEN ? AND ?
            OR DTFIMMOVIMENT IS NULL)',
            array(
                $nrOrg, $nrVinculo, $dtInicio, $dtFim,
            ),
            'DTINIMOVIMENT'
            
        );

        return $resultado;
    }


    /**
     * Retorna a movimentacao anterior do vinculo de acordo com a data de movimentacao informada.
     *
     * @param string  $mesCompetencia  Mes de competencia.
     * @param integer $nrOrg           Numero da organizacao.
     * @param integer $nrVinculo       Tipo do registro.
     * @param string  $dtMovimentacao  Tipo do registro.
     * @param array   $cdCagedAdmissao Tipo do registro.
     *
     * @return null || array
     *
     * @author thalesvalias 12/06/2012
     */
    public static function retornaMovimentacaoAnterior($mesCompetencia, $nrOrg, $nrVinculo, $dtMovimentacao, $cdCagedAdmissao){
        $implodeCagedAdmissao = implode(', ', $cdCagedAdmissao);

        $sql = "SELECT * FROM GPE_MOVIMENTACAO
                WHERE NRORG = $nrOrg
                AND NRVINCULOM = $nrVinculo
                AND DTINIMOVIMENT = (SELECT MAX(GPE_MOVIMENTACAO.DTINIMOVIMENT)
                                     FROM GPE_MOVIMENTACAO
                                     INNER JOIN GPE_TPMOVTRANSFM
                                      ON GPE_MOVIMENTACAO.NRTPMOVTRANSFM = GPE_TPMOVTRANSFM.NRTPMOVTRANSFM
                                     INNER JOIN GPE_TPMOVTRANSFH
                                      ON GPE_TPMOVTRANSFM.NRTPMOVTRANSFM = GPE_TPMOVTRANSFH.NRTPMOVTRANSFM
                                     WHERE GPE_MOVIMENTACAO.NRORG = $nrOrg
                                     AND GPE_MOVIMENTACAO.NRVINCULOM = $nrVinculo
                                     AND GPE_MOVIMENTACAO.DTINIMOVIMENT < '$dtMovimentacao'
                                     AND GPE_TPMOVTRANSFH.CODCAGED IN ($implodeCagedAdmissao)
                                     AND GPE_TPMOVTRANSFH.DTMESCOMPETENC IN (SELECT MAX(DTMESCOMPETENC)
                                                                             FROM GPE_TPMOVTRANSFH
                                                                             WHERE NRTPMOVTRANSFM = GPE_TPMOVTRANSFM.NRTPMOVTRANSFM
                                                                             AND DTMESCOMPETENC <= '$mesCompetencia'))";

        $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);

        return $result;
    }

    /**
     * @param $nrorg
     * @param $nrtipoestrutura
     * @param $nrvinculom
     * @return GpemovimentacaoEntity
     */
    public static function getMovimentacao($nrorg, $nrtipoestrutura, $nrvinculom) {
        $db = \Setforms2\Shared\Connection::getInstance()->getConn();
        $dtmescompetencia = \FPA::getUltimoDiaMes();
        $sql = <<<SQL
SELECT * FROM GPE_MOVIMENTACAO
            WHERE NRORG           = ?
              AND NRTIPOESTRUTURA = ?
              AND NRVINCULOM      = ?
              AND DTINIMOVIMENT   = (SELECT MAX(DTINIMOVIMENT)
                                      FROM GPE_MOVIMENTACAO
                                     WHERE NRORG           = ?
                                       AND NRTIPOESTRUTURA = ?
                                       AND NRVINCULOM      = ?
                                       AND DTINIMOVIMENT  <= ?)
SQL;

        $params = array($nrorg, $nrtipoestrutura, $nrvinculom, $nrorg, $nrtipoestrutura, $nrvinculom, $dtmescompetencia);

        $result = $db->fetchAll($sql, $params);
        if (end($result)) {
            $result = end(self::createObjectsFromArray($result));
        }
        return $result;
    }

    /**
     * @param $nrorg
     * @param $nrtipoestrutura
     * @param $nrvinculom
     * @return GpemovimentacaoEntity
     * @author leonardocarvalho - 03/10/2014
     */
    public static function getMovimentacoes($nrorg, $nrtipoestrutura, $nrvinculom) {
        $db = \Setforms2\Shared\Connection::getInstance()->getConn();
        $dtmescompetencia = \FPA::getUltimoDiaMes();
        $sql = <<<SQL
SELECT * FROM GPE_MOVIMENTACAO
            WHERE NRORG           = ?
              AND NRTIPOESTRUTURA = ?
			  AND NRTIPOTRANSFER  = 1
              AND NRVINCULOM      = ?
              AND DTINIMOVIMENT   = (SELECT MAX(DTINIMOVIMENT)
                                      FROM GPE_MOVIMENTACAO
                                     WHERE NRORG           = ?
                                       AND NRTIPOESTRUTURA = ?
                                       AND NRVINCULOM      = ?
                                       AND DTINIMOVIMENT  <= ?)
SQL;

        $params = array($nrorg, $nrtipoestrutura, $nrvinculom, $nrorg, $nrtipoestrutura, $nrvinculom, $dtmescompetencia);

        $result = $db->fetchAll($sql, $params);
        $result = self::createObjectsFromArray($result);
        return $result;
    }

    /**
     * @param $nrorg
     * @param $nrtipoestrutura
     * @param $nrvinculom
     * @return \GpemovimentacaoEntity
     */
    public static function getUltimaMovimentacaoPorTipo($nrorg, $nrtipoestrutura, $nrvinculom) {
        $params = array($nrorg, $nrtipoestrutura, $nrvinculom, $nrorg, $nrtipoestrutura, $nrvinculom);
        $where = <<<SQL
    NRORG           = ?
AND NRTIPOESTRUTURA = ?
AND NRVINCULOM      = ?
AND DTINIMOVIMENT   = (SELECT MAX(DTINIMOVIMENT)
                          FROM \Gpemovimentacao
                         WHERE NRORG           = ?
                           AND NRTIPOESTRUTURA = ?
                           AND NRVINCULOM      = ?)
SQL;

        return self::getObjectByWhere($where, $params);
    }

}